﻿using System;
using System.IO;

class CompareTextFiles
{
    /// <summary>
    /// Write a program that compares two text files line by line and prints
    /// the number of lines that are the same and the number of lines that 
    /// are different. Assume the files have equal number of lines.
    /// </summary>

    static void Main(string[] args)
    {
        // Create two readers with the Cyrillic encoding
        StreamReader firstStreamReader = new StreamReader("../../Files/test.001.in.1.txt");
        StreamReader secondStreamReader = new StreamReader("../../Files/test.001.in.2.txt");

        // Create counters for the same and the different text lines
        int counterOfEqualLines = 0;
        int counterOfDifferentLines = 0;

        // Use the two StreamReaders
        using (firstStreamReader)
        {
            using (secondStreamReader)
            {
                StreamWriter streamWriter = new StreamWriter(
                    "../../Files/test.001.out.txt", false);
                using (streamWriter)
                {
                    // Read the lines of the two text files
                    string firstFileLines = firstStreamReader.ReadLine();
                    string secondFileLines = secondStreamReader.ReadLine();
                    while (secondFileLines != null)
                    {

                        // Compare the two text files line by line 
                        if (firstFileLines.CompareTo(secondFileLines) == 0)
                        {
                            counterOfEqualLines++;
                        }
                        else
                        {
                            counterOfDifferentLines++;
                        }
                        firstFileLines = firstStreamReader.ReadLine();
                        secondFileLines = secondStreamReader.ReadLine();
                    }
                    streamWriter.WriteLine(counterOfEqualLines);
                    streamWriter.WriteLine(counterOfDifferentLines);
                }
                    
            }
        }

        // Print the number of same and the different lines 
        Console.WriteLine("The number of lines that are the same is: {0}",
            counterOfEqualLines);
        Console.WriteLine("The number of lines that are different is: {0}",
            counterOfDifferentLines);
    }
}
