﻿using System;
using System.IO;
using System.Text;

class DeleteAllOddLinesInTheSameFile
{
    /// <summary>
    /// Write a program that deletes from given 
    /// text file all odd lines. The result should be in the same file.
    /// </summary>

    static void Main(string[] args)
    {
        // Getting Cyrillic encoding 
        System.Text.Encoding encoding = System.Text.Encoding.GetEncoding(1251);

        // Create reader with the Cyrillic encoding
        StreamReader streamReader = new StreamReader(
            "../../Files/test.001.out.txt", encoding);

        // Using StringBuilder 
        StringBuilder text = new StringBuilder();

        using (streamReader)
        {
            int lineCounter = 0;

            // Find odd lines of the text file
            string oddLineContent = streamReader.ReadLine();
            while (oddLineContent != null)
            {
                lineCounter++;

                if (lineCounter % 2 == 0)
                {
                    text.AppendLine(oddLineContent);
                }

                oddLineContent = streamReader.ReadLine();
            }
        }

        // Create writer with the Cyrillic encoding
        StreamWriter streamWriter = new StreamWriter(
            "../../Files/test.001.out.txt", false, encoding);
        using (streamWriter)
        {
            streamWriter.Write(text.ToString());
        }
    }
}
