﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;

class CountWordsAndSortByNumberOfOccurrences
{
    /// <summary>
    /// Write a program that reads a list of words from a file words.txt 
    /// and finds how many times each of the words is contained in another
    /// file test.txt. The result should be written in the file result.txt
    /// and the words should be sorted by the number of their occurrences
    /// in descending order. Handle all possible exceptions in your methods.
    /// </summary>

    static void Main(string[] args)
    {
        try
        {
            ReadAndCountWords("../../Files/test.001.in.test.txt",
                "../../Files/test.001.in.words.txt",
                "../../Files/test.001.out.result.txt");
        }
        catch (FileNotFoundException exception)
        {
            Console.WriteLine(exception.Message);
        }
    }

    static void ReadAndCountWords(string inputTextFile,
        string listOfWords, string outputTextFile)
    {
        using (StreamReader textFile = new StreamReader(inputTextFile))
        {
            using (StreamReader wordsFile = new StreamReader(listOfWords))
            {
                using (StreamWriter resultFile = new StreamWriter(outputTextFile))
                {
                    string fileContent = textFile.ReadToEnd();
                    char[] splitSymbols = { ' ', ',', '.', ';', ':', 
                                                '?', '!', '-', '(', 
                                                ')', '\n', '\r', '\t' };
                    string[] words = fileContent.Split(splitSymbols,
                        StringSplitOptions.RemoveEmptyEntries);
                    string[] keyWords = wordsFile.ReadToEnd().Split(splitSymbols,
                        StringSplitOptions.RemoveEmptyEntries);

                    Dictionary<string, int> dict = new Dictionary<string, int>();
                    Dictionary<string, int> result = new Dictionary<string, int>();

                    foreach (string keyWord in keyWords)
                    {
                        dict.Add(keyWord, 0);
                    }

                    foreach (var item in dict)
                    {
                        int counter = 0;
                        foreach (string word in words)
                        {
                            if (word.Contains(item.Key))
                            {
                                counter++;
                            }
                        }
                        result.Add(item.Key, counter);
                    }

                    var query = from table in result
                                orderby table.Value
                                    descending
                                select new { table.Key, table.Value };

                    foreach (var row in query)
                    {
                        resultFile.WriteLine("{0} --> {1} times", row.Key, row.Value);
                    }
                }
            }
        }
    }
}