﻿using System;
using System.Collections.Generic;
using System.IO;

class SortAndSave
{
    /// <summary>
    /// Write a program that reads a text file containing a list of strings,
    /// sorts them and saves them to another text file. Examle
    /// Ivan    ->   George
    /// Peter   ->   Ivan
    /// Maria   ->   Maria
    /// George  ->   Peter
    /// </summary>

    static void Main(string[] args)
    {
        // Getting Cyrillic encoding 
        System.Text.Encoding encoding = System.Text.Encoding.GetEncoding(1251);

        // Save every name into a list
        List<string> names = new List<string>();

        // Create reader with the Cyrillic encoding
        StreamReader streamReader = new StreamReader("../../Files/test.001.in.txt", encoding);
        using (streamReader)
        {
            string line = streamReader.ReadLine();
            while (line != null)
            {
                names.Add(line);
                
                line = streamReader.ReadLine();
            }
        }
        names.Sort();

        // Create writer with the Cyrillic encoding
        StreamWriter streamWriter = new StreamWriter("../../Files/test.001.out.txt", false, encoding);
        using (streamWriter)
        {
            for (int i = 0; i < names.Count; i++)
            {
                streamWriter.WriteLine(names[i]);
                Console.WriteLine(names[i]);
            }
        }
    }
}
